/*************************************************************************
 ** Ȩ(C), 2001-2013, 㽭󻪼ɷ޹˾.
 ** Ȩ.
 **
 ** $Id$
 **
 **    : Proxy Client C
 **
 ** ޸ʷ     : 20131223 zhu_long Modification
*************************************************************************/

#ifndef _DAHUA_P2P_PROXY_CLIENT_CWRAP_H_
#define _DAHUA_P2P_PROXY_CLIENT_CWRAP_H_

#include "Defs.h"

#ifdef WIN32
	typedef unsigned __int64 UINT64;
#else
	typedef unsigned long long UINT64;
#endif

#ifdef  __cplusplus
extern "C" {
#endif

///\brief ״̬
typedef enum
{
    DHProxyStateUnauthorized,           ///< ֤ʧܣкŷǷԿ
    DHProxyStateForbidden,              ///< ֹ½豸IDظܾ
    DHProxyStateOffline,                ///< 
    DHProxyStateOnline,                 ///< 
} DHProxyClientProxyState;

///\brief P2Pͨ״̬
typedef enum
{
    DHP2PChannelStateInit,              ///< P2Pͨʼ
    DHP2PChannelStateActive,            ///< P2Pͨͨ
    DHP2PChannelStateNonExist,          ///< P2Pͨ
	DHP2PChannelStateUnauthorized,      ///< P2PͨȨʧ
} DHProxyClientP2PChannelState;

///\brief ӳ˿ͳ
typedef struct
{
    UINT64               recvBytes;     ///< ֽܽKB
    UINT64               sendBytes;     ///< ֽܷKB

    double               curRecvRate;   ///< ǰKb/s
    double               curSendRate;   ///< ǰKb/s

    double               lostRate;      ///< 
    double               liveTime;      ///< ͨʱ(S)
} DHProxyClientMapPortRate;

///\brief Զ̴Ϣ
typedef struct
{
    char                remoteId[64];      ///< ID
    char                remoteIp[64];      ///< Զ̴IP
    int                 remotePort;        ///< Զ̴˿
} DHProxyClientRemotePortInfo;

typedef enum
{
    DHP2POptionPortGuess,                 ///< ˿ڲ²ѡ ֵ: 0 ر 1 
    DHP2POptionSetMTU,                    ///< MTUѡ	  ֵ: ֵ
    DHP2POptionUPNP,                      ///< UPNPѡ	  ֵ: 0 ر 1 
    DHP2POptionRelay,                     ///< Relayѡ  ֵ: 0 ֧ת 1 ֧ת
    DHP2POptionPTCPThreadNum,             ///< PTCP߳Ŀѡ  ֵ: ֵ    
    DHP2POptionRecvBufSize,               ///< P2PջСλ:ֽ
    DHP2POptionPTCPSendBuffer,            ///< PTCPͻСλ:ֽ
    DHP2POptionPTCPRecvBuffer,            ///< PTCPջСλ:ֽ
    DHP2POptionSendBufSize,               ///< TCPͻСλ:ֽ
    DHP2POptionLocal,                     ///< Localѡ     ֵ0 ֧־ 1 ֧־
    DHP2POptionLinkSwitch,                ///< ·лѡ  ֵ: 0 ر·л  1 ֧·л,ѡֻԴͻЧ
    DHP2POptionRemoteCommand,             ///< Զѡ  ֵ0 ر 1 
    DHP2POptionMultiHolePunch,            ///< شѡ  ֵ: 0 ر 1 , ĬϿ
    DHP2POptionIceDefaultRange,           ///< ICEĬϳµĲ²ⷶΧ
    DHP2POptionIceConeVsSymmRange,        ///< ICEԲ׶ԳͳµĲ²ⷶΧ
    DHP2POptionIceSymmVsSymmRange,        ///< ICEԳԳͳµĲ²ⷶΧ
    DHP2POptionLinkSwitchSpace,           ///< ·л
}DHProxyOption;


///\brief ־
typedef enum
{
    DHProxyLogLevelSilent,                /// < ü𲻴ӡϢ
    DHProxyLogLevelErr,                   /// < 
    DHProxyLogLevelWarning,               /// < ܵ³
    DHProxyLogLevelInfo,                  /// < ֪ûǰ״̬
    DHProxyLogLevelTrace,                 /// < Ϣ
    DHProxyLogLevelDebug                  /// < ϸϢ
}DHProxyLogLevel;

///\brief 
typedef void*	ProxyClientHandler;

///\bried ͻϱ͸Ϣص
///\param deviceId    豸к
///\param deviceIp    豸NATIP
///\param devicePort  豸NATĶ˿
///\param clientIp    ͻNATIP
///\param clientPort  ͻNATĶ˿
///\param linkType    (0:; 1:P2P; 2:ת)
typedef void (* DHP2PTraversalInfoHandler)(const char *deviceId, const char *deviceIp, const int devicePort, const char *clientIp, const int clientPort, const int linkType);

///\brief ʼ
///\param[in]       svraddr  IP(ݲ֧)
///\param[in]       svrport  ˿
///\param[in]       passwd   Կ
///\return 0ʧ/client
///\note ʹUDPأð󳤶ȣѡΪDHP2POptionSetMTU
///\     ֵ1400ֽ
TOU_API ProxyClientHandler DHProxyClientInit(const char* svrip, int svrport, const char* passwd);

///\brief ͷԴ
///\param[in]       handler  ʵclient
TOU_API void DHProxyClientRelease(ProxyClientHandler handler);

///\brief ͨԶ̴ӳ(첽ģʽ)
///\param[in]       handler  ʵclient
///\param[in]       deviceId    Զ̴ID
///\param[in]       targetPort  Ŀ˿
///\param[in,out]   localPort   ӳ˿,Ϊ0ڲһ˿
///\return 0Ӷ˿ӳɹ/-1Ӷ˿ӳʧ
///\note ͨǷɹDHProxyClientChannelstateӿڲѯ
TOU_API int DHProxyClientAddPort(ProxyClientHandler handler,
		const char* deviceId, int targetPort, int *localPort);

///\brief ͨԶ̴ӳ(ͬģʽ)
///\param[in]       handler  ʵclient
///\param[in]       deviceId    Զ̴ID
///\param[in]       targetPort  Ŀ˿
///\param[in,out]   localPort   ӳ˿,Ϊ0ڲһ˿
///\param[in]       timeOut     ʱʱ(λ:)
///\note timeOutΪ0 óʱʱ, ֱн
///\return 0ͨɹ/-1ͨʧ
TOU_API int DHProxyClientAddPortSync(ProxyClientHandler handler, 
        const char *deviceId, int targetPort, int *localPort, unsigned int timeOut);

///\brief ɾһӳ
///\param[in]   handler  ʵclient
///\param[in]   port ӳ˿
///\return 0ɹ/-1ʧ
TOU_API int DHProxyClientDelPort(ProxyClientHandler handler, int port);

///\brief ѯӳ˿
///\param[in]   handler  ʵclient
///\param[in]   port ӳ˿
///\param[out]  rate ǰӳ
///\return 0ɹ/-1ʧ
TOU_API int DHProxyClientQueryRate(ProxyClientHandler handler,
		int port, DHProxyClientMapPortRate *rate);

///\brief ѯӳ˿ڵP2Pͨ״̬
///\param[in]   handler  ʵclient
///\param[in]   port ӳ˿
///\param[out]  state ǰӳ˿״̬ @see DHProxyClientP2PChannelState
///\return 0ɹ/-1ʧ
TOU_API int DHProxyClientChannelstate(ProxyClientHandler handler, int port, int *state);

///\brief ȡǰͻ״̬
///\param[in]   handler  ʵclient
///\param[out] 	state  ǰͻ״̬, @see DHProxyClientProxyState
///\return 0ɹ/-1ʧ
TOU_API int DHProxyClientState(ProxyClientHandler handler, int *state);

///\brief ѯԶ̴״̬
///\param[in]   handler  ʵclient
///\param[in]   deviceId Զ̴ID
///\param[out] 	state ǰ״̬, @see DHProxyClientProxyState
///\return 0ɹ/-1ʧ
TOU_API int DHProxyClientServerState(ProxyClientHandler handler, const char* deviceId, int *state);

///\brief ѯԶ̴Ϣ
///\param[in]   handler  ʵclient
///\param[in]   port  ˿
///\param[out]  info  Զ̴Ϣ, @see DHProxyClientRemotePortInfo
///\return 0ɹ/-1ʧ
TOU_API int DHProxyClientQueryRemoetInfo(ProxyClientHandler handler, int port, DHProxyClientRemotePortInfo *info);

///\breif ʼ
///\param[in]       svraddr  IP(ݲ֧)
///\param[in]       svrport  ˿
///\param[in]       passwd   Կ
///\param[in]       username   û
///\return 0ʧ/client
TOU_API ProxyClientHandler DHProxyClientInitWtihName(const char* svrip, int svrport, const char* passwd, const char* username);

///\brief Proxyѡ
///\param[in]   handler  ʵclient
///\param[in] option ProxyOptionö
///\param[in] value òֵ
///\return 0 ɹ; -1 ʧ
///\note value @see ProxyOption
TOU_API	int DHProxySetOption(ProxyClientHandler handler, DHProxyOption option, int value);

///\brief ȡӦoptionֵ
///\param[in] handler  ʵclient
///\param[in] option ProxyOptionö
///\return õĲֵ: -1 ʧ; >=0 optionֵ 
TOU_API int DHProxyGetOption(ProxyClientHandler handler, DHProxyOption option);

///\brief ־,ڸü־
///\param[in] handler   ʵclient
///\param[in] level     DHProxyLogLevelö
///\note level @see DHProxyLogLevel
///\note Ĭ־Ϊ DHProxyLogLevelDebug
TOU_API void DHProxySetLogLevel(ProxyClientHandler handler, DHProxyLogLevel level);

///\brief ȡ豸Ϣ
///\param[in]      handler    ʵclient
///\param[in]      deviceId   豸к
///\param[in]      bufferLen  洢豸ϢĻ
///\param[out]     deviceInfo 豸Ϣ
///\return trueɹ/falseʧ
TOU_API bool DHProxyGetDeviceInfo(ProxyClientHandler handler, const char *deviceId, int bufferLen, char *deviceInfo);

///\brief עϱ͸ϢĻص
///\param[in]      handler         ʵclient
///\param[in]      reportHandler   ͸ϢϱĻص @see DHP2PTraversalInfoHandler
///\note ûصP2Pϲϱ͸Ϣ
///\note ڸûصдϲҵ񣬷ֹP2Pڲ߳
TOU_API void DHProxyRegP2PTraversalInfoHandler(ProxyClientHandler handler, const DHP2PTraversalInfoHandler reportHandler);

#ifdef  __cplusplus
}
#endif

#endif /* _DAHUA_P2P_PROXY_CLIENT_CWRAP_H_ */
