//
//  API.h
//  DHSDKWrapper
//
//  Created by qq on 2019/9/9.
//  Copyright © 2019 yhy. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "netsdk.h"


NS_ASSUME_NONNULL_BEGIN
@interface LoginForm : NSObject
@property (strong, nonatomic) NSString* IP;
@property (strong, nonatomic) NSString* port;
@property (strong, nonatomic) NSString* userName;
@property (strong, nonatomic) NSString* password;
@property (strong, nonatomic) NSString* name;
@property (strong, nonatomic) NSString* describe;
@end

@interface LoginResult : LoginForm
@property(assign, nonatomic) LLONG loginId;
@property(assign, nonatomic) int channel;

@end

@interface DHAPI : NSObject

// 登录
+ (void)IPLogin:(LoginForm*)form success:(void (^)(LoginResult* result))success
         failed:(void (^)(NSError* error))failed;
// 退出登录
+ (void)loginOut:(LLONG)loginId;
@end

NS_ASSUME_NONNULL_END
