/************************************************************
 *  * Hyphenate CONFIDENTIAL
 * __________________
 * Copyright (C) 2016 Hyphenate Inc. All rights reserved.
 *
 * NOTICE: All information contained herein is, and remains
 * the property of Hyphenate Inc.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Hyphenate Inc.
 */

#import <UIKit/UIKit.h>
#import "MBProgressHUD.h"

@interface UIViewController (HUD)

@property(strong,nonatomic)MBProgressHUD *HUD;

- (void)showHudInView:(UIView *)view hint:(NSString *)hint;

- (void)hideHud;

- (void)showHint:(NSString *)hint;

- (void)showHint:(NSString *)hint delay:(CGFloat)delay;

// 从默认(showHint:)显示的位置再往上(下)yOffset
- (void)showHint:(NSString *)hint yOffset:(float)yOffset;

// 20170607 Change
- (MBProgressHUD*)showHUDIndeterminate;
- (MBProgressHUD*)showHUDIndeterminateWithText:(NSString *)text;
- (void)hideHUDIndeterminate;
- (MBProgressHUD*)showHUDWithDetailText:(NSString *)text;
- (MBProgressHUD*)showHUDWithText:(NSString *)text detailText:(NSString *)detailText;
- (MBProgressHUD*)showHUDWithText:(NSString *)text detailText:(NSString *)detailText afterDelay:(float)afterDelay;

// Custom -iamge with title
//isHaveNavBar 控制器是否含有 导航条
- (MBProgressHUD*)showHUDWithCustomImage:(NSString *)imageName WithText:(NSString *)text isHaveNavBar:(BOOL )isBar;
// yhy added this method -- 支持文字换行显示
-(void)showDetail:(NSString*)text;
// yhy added this method -- 支持文字换行显示
-(void)showDetail:(NSString*)text delay:(double)delay fontSize:(CGFloat)fontSize;

@end
