import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:zhgd_native_plugin/zhgd_native_plugin.dart';

void main() {
  const MethodChannel channel = MethodChannel('origin_channel');

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('hello', () async {
    expect(await ZhgdNativePlugin.platformVersion, '42');
  });
}
